﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Documents.Excel;
using System.IO;
using SilverlightApplication8.Web;
using System.ServiceModel.DomainServices.Client;

namespace SilverlightApplication8
{
    public partial class MainPage : UserControl
    {
        DomainDataSource northWndDataSource = new DomainDataSource();
        NorthwndDomainContext northWndContext = new NorthwndDomainContext();

        Workbook workbook;
        Stream workbookStream;

        public MainPage()
        {
            InitializeComponent();

            northWndDataSource.DataContext = northWndContext;
            northWndDataSource.LoadedData += new EventHandler<LoadedDataEventArgs>(northWndDataSource_LoadedData);

            LoadOperation<Order> loadOp = northWndContext.Load(northWndContext.GetOrdersQuery());

            xamGrid1.ItemsSource = loadOp.Entities;
        }

        void northWndDataSource_LoadedData(object sender, LoadedDataEventArgs e)
        {
            if (e.HasError)
            {
                System.Windows.MessageBox.Show(e.Error.ToString(), "Load Error", System.Windows.MessageBoxButton.OK);
                e.MarkErrorAsHandled();
            }
        }

        private void btnExport_Click(object sender, RoutedEventArgs e)
        {
            SaveFileDialog saveDialog = new SaveFileDialog();
            saveDialog.DefaultExt = "xlsx";
            saveDialog.Filter = "Excel Workbook (.xlsx)|*.xlsx";

            if (saveDialog.ShowDialog().Value)
            {
                try
                {
                    workbookStream = saveDialog.OpenFile();
                    workbook = new Workbook();
                    Worksheet worksheet = workbook.Worksheets.Add("Sheet1");
                    workbook.SetCurrentFormat(WorkbookFormat.Excel2007);

                    // Export xamGrid data to the created Workbook object
                    excelExporter.ExportAsync(xamGrid1, workbook);

                    BusyIndicator.Visibility = System.Windows.Visibility.Visible;
                }
                catch (Exception exc)
                {
                    MessageBox.Show(exc.Message);
                }
            }
        }

        private void XamGridExcelExporter_ExportEnded(object sender, EventArgs e)
        {
            workbook.Save(workbookStream);
            workbookStream.Close();

            BusyIndicator.Visibility = System.Windows.Visibility.Collapsed;
        }

        private void excelExporter_CellExporting(object sender, Infragistics.Controls.Grids.XamGridExcelExporterCellExportingEventArgs e)
        {

        }
    }
}
